/* Задача "Прыгучее путешевствие"
 * Интернет олимпиады для школьников. Сезон 2006 - 2007
 * Автор задачи:  Александр Торопов, toropov@rain.ifmo.ru
 * Автор решения: Александр Торопов, toropov@rain.ifmo.ru
 */

import java.io.*;
import java.util.*;


public class jump_at implements Runnable {
	Scanner in;
	PrintWriter out;
	
	class Point {
		public int x, y;
		
		public Point(int X, int Y) {
			x = X; y = Y;
		}
		
		public double sqrDistTo(Point a) {
			return (x - a.x) * (x - a.x) + (y - a.y) * (y - a.y);
		}
	}
	
	public void run() {
		int n = in.nextInt();
		Point B = new Point(in.nextInt(), in.nextInt());
		int l = in.nextInt();
		for(int i = 0; i < n; ++i) {
			Point A = new Point(in.nextInt(), in.nextInt());
			if (A.sqrDistTo(B) <= l * l) {
				out.print(i + 1);
				out.close();
				return ;
			}
		}
		out.print("Yes");
		out.close();
	}

	private jump_at(String name) {
		try {
			in = new Scanner(new File(name + ".in"));
			out = new PrintWriter(new File(name + ".out"));
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(89);
		}
	}
	
	public static void main(String[] args) {
		(new Thread(new jump_at("jump"))).start();
	}

}
